<?php

// Simple InUSE Check
if ( !defined('QF_STARTED') )
        die('Hacking attempt');

class Fox2_adm
{
    function _Start()
    {
        global $QF;
        $QF->LNG->Load_Language('admin');
    }

    function Page_AdmPanel(&$p_title, &$p_subtitle, &$d_result)
    {
        global $QF, $FOX;

        $QF->VIS->Load_Templates('admin');

        if (!$QF->User->UID || !$QF->User->adm_level)
        {
            $d_result = Array(Lang('ADMPANEL_ERR_NOADMIN'), QF_INDEX, true);
            //header ($QF->HTTP->SERVER["SERVER_PROTOCOL"].' 403 Forbidden');
        }
        elseif (!$QF->User->S_Get('adm_logged'))
        {
            $p_title = $QF->LNG->Lang('PAGE_ADMPANEL_CAPT');
            return $QF->VIS->Create_Node('ADM_PAN_LOGIN', Array('URI' => $QF->HTTP->Request) );
        }
        else
        {
            $adm_pans = Array(            // On Devel - needs to be stored in datasets
                'configs' => 'L_ADMTAB_CONFIGURER',
                'menued'  => 'L_ADMTAB_MENUEDITOR',
                'cms'     => 'L_ADMTAB_CMSCONTROL',
                'users'   => 'L_ADMTAB_USERS',
                );

            $c_panel = $QF->GPC->Get_String('admp', QF_GPC_GET, QF_STR_WORD);
            if (!$c_panel)
                $c_panel = $QF->Session->Get('last_admp');
            if (!$c_panel || !isset($adm_pans[$c_panel]))
                $c_panel = 'configs';

            $QF->Session->Set('last_admp', $c_panel);

            $p_title = $QF->LNG->Lang('PAGE_ADMPANEL_CAPT');
            $ADM_FRAME = $QF->VIS->Create_Node('ADM_PAGE_MAIN', false, 'ADM_FRAME');
            foreach ($adm_pans as $pid => $pname)
            {
                if (substr($pname, 0, 2) == 'L_')
                    $pname = $QF->LNG->Lang(substr($pname, 2));

                $tab = $QF->VIS->Add_Node('ADM_PAGE_TAB', 'TABS', $ADM_FRAME, Array('href' => $FOX->Gen_URL('fox2_adm_panel_admp', Array($pid), true), 'caption' => $pname) );
                if ($c_panel == $pid)
                {
                    $QF->VIS->Add_Data($tab, 'SELECTED', 1);
                    $QF->VIS->Add_Data($ADM_FRAME, 'PANEL_SUBTITLE', $pname);
                    $p_subtitle = $pname;
                }
            }

            // we'll load and run selected adm page
            // it must return node ID and use $p_subtitle to set panel subtitle
            if (($data = $QF->DSets->Get_DSet_Value('fox_admpanels', $c_panel)) && isset($data['module'], $data['method']))
            {
                $QF->Run_Module($data['module']);
                $admp_subtitle = '';
                $admd_result = false; // not implemented
                $pg_node = qf_func_call_arr(Array(&$QF->$data['module'], $data['method']), Array(&$admp_subtitle, &$admd_result));
                if ($pg_node)
                    $QF->VIS->Append_Node($pg_node, 'ADM_FRAME', $ADM_FRAME);
                if ($p_subtitle)
                    $QF->VIS->Add_Data($ADM_FRAME, 'PFRAME_SUBTITLE', $admp_subtitle);
            }


            return $ADM_FRAME;
        }
    }

    function AdmP_Users(&$p_subtitle)
    {
        global $QF, $FOX;

        $QF->Run_Module('UList');

        $list = $QF->UList->Get_List();

        $list = array_values($list);
        $cfg_node = $QF->VIS->Create_Node('ADM_FRAME_USERS_LIST', Array('MAX_ADM' => $QF->User->adm_level - 1));

        $QF->UList->Query_IDs($list);
        $uss_data = Array();
        foreach ($list as $uid)
        {
            $udata = $QF->UList->Get_UserInfo($uid);

            if ($udata['a_lvl'] < $QF->User->adm_level)
                $udata['can_edit'] = '1';
            $uss_data[] = $udata;
        }

        $QF->VIS->Add_Node_Array('ADM_FRAME_USERS_ITEM', 'ITEMS_DATA', $cfg_node, $uss_data);
        return $cfg_node;
    }

    function Script_Users()
    {
        global $QF, $FOX;

        $QF->Run_Module('UList');
        $action = $QF->GPC->Get_String('mode', QF_GPC_POST, QF_STR_WORD);

        if ($acc_err = $this->_Scr_Check_Access())
        {
            return $acc_err;
        }
        elseif ($action == 'multi_edit')
        {
            $uids = $QF->GPC->Get_Raw('sel_user', QF_GPC_POST);
            $QF->UList->Query_IDs($uids);
            $edit_users = Array();
            foreach ($uids as $uid)
            {
                $udata = $QF->UList->Get_UserInfo($uid);

                if ($udata['a_lvl'] < $QF->User->adm_level)
                    $edit_users[] = $uid;
            }

            if (!count($edit_users))
                return Array($QF->LNG->Lang('ERR_ADMPANEL_USERS_NONE_SEL'), $FOX->Gen_URL('fox2_adm_panel_admp', 'users'), true);

            $adm_level = $QF->GPC->Get_Num('adm_level', QF_GPC_POST);
            if ($adm_level == -1)
                $adm_level = false;
            $mod_level = $QF->GPC->Get_Num('mod_level', QF_GPC_POST);
            if ($mod_level == -1)
                $mod_level = false;
            $acc_level = $QF->GPC->Get_Num('acc_level', QF_GPC_POST);
            if ($acc_level == -1)
                $acc_level = false;

            if ($QF->UList->Set_Levels($edit_users, $acc_level, $mod_level, $adm_level))
            {
                $result = sprintf($QF->LNG->Lang('RES_ADMPANEL_USERS_ACC_UPDATED'), count($edit_users));
                return Array($result, $FOX->Gen_URL('fox2_adm_panel_admp', 'users'));
            }
            else
                return Array($QF->LNG->Lang('ERR_ADMPANEL_USERS_ACC_UPD'), $FOX->Gen_URL('fox2_adm_panel_admp', 'users'), true);
        }
        elseif ($action == 'force_create')
        {

            $nuser = substr($QF->GPC->Get_String('user_login', QF_GPC_POST), 0, 16);
            $npasssrc1 = $QF->GPC->Get_String('user_pass', QF_GPC_POST);
            $npass1 = md5($npasssrc1);

            if (!preg_match('#'.UNAME_MASK.'#i', $nuser))
                return Array($QF->LNG->lang('ERR_ADMPANEL_USERS_LOGIN_BAD'), $FOX->Gen_URL('fox2_adm_panel_admp', 'users'), true);
            elseif (strlen($npasssrc1) < 1)
                return Array($QF->LNG->lang('ERR_ADMPANEL_USERS_PASS_BAD'), $FOX->Gen_URL('fox2_adm_panel_admp', 'users'), true);
            elseif ($QF->DBase->Do_Delete('users', Array('nick' => $nuser)))
                return Array($QF->LNG->lang('ERR_ADMPANEL_USERS_NICK_USED'), $FOX->Gen_URL('fox2_adm_panel_admp', 'users'), true);
            elseif ($QF->DBase->Do_Delete('users_auth', Array('login' => $nuser)))
                return Array($QF->LNG->lang('ERR_ADMPANEL_USERS_LOGIN_USED'), $FOX->Gen_URL('fox2_adm_panel_admp', 'users'), true);
            else
            {
                $ins_data = Array(
                    'nick'     => $nuser,
                    'regtime'  => $QF->Timer->time,
                    'level'    => 1,
                    'mod_lvl'  => 0,
                    'adm_lvl'  => 0,
                    'av_sig'   => '',
                    );
                if ($nid = $QF->DBase->Do_Insert('users', $ins_data))
                {
                    $ins_data = Array(
                        'uid'       => $nid,
                        'login'     => $nuser,
                        'pass_hash' => $npass1,
                        //'sys_email' => $nemail,
                        );
                    if ($QF->DBase->Do_Insert('users_auth', $ins_data))
                    {
                        $result = sprintf($QF->LNG->Lang('RES_ADMPANEL_USERS_CREATED'), $nuser);
                        return Array($result, $FOX->Gen_URL('fox2_adm_panel_admp', 'users'));
                    }
                    else
                        $QF->DBase->Do_Delete('users', Array('uid' => $nid));
                }
            }

            return Array($QF->LNG->lang('ERR_ADMPANEL_USERS_NOTCREATED'), $FOX->Gen_URL('fox2_adm_panel_admp', 'users'), true);
        }
        else
            return Array($QF->LNG->lang('ADMPANEL_QUERY_ERROR'), $FOX->Gen_URL('fox2_adm_panel_admp', 'users'), true);
    }

    function DPage_GetFile()
    {
        global $QF, $FOX;

        // first we need to load session data to determine if user is allowed to download the file
        $QF->Session->Open_Session();

        if ($acc_err = $this->_Scr_Check_Access())
        {
            return $acc_err;
        }
        else
        {
            $fname = $QF->GPC->Get_String('file', QF_GPC_GET);
            if (file_exists($fname))
            {
                $fname = realpath($fname);
                $myroot = realpath($QF->HTTP->SERVER['DOCUMENT_ROOT']);
                if (strpos($fname, $myroot)===0)
                {
                    $fext = pathinfo($fname, PATHINFO_EXTENSION);
                    $ftype = qf_file_mime($fname, $fext);
                    $QF->HTTP->Send_File($fname, $fname, $ftype['mime']);
                }
                else
                    trigger_error('FOX_ADM: admin UID'.$QF->User->UID.' tried to get file "'.$fname.'" from the system', E_USER_ERROR);
            }
        }

        $FOX->Set_Result(Lang('NO_DATA').$fname, QF_INDEX, true);
    }

    function AdmP_Config(&$p_subtitle)
    {
        global $QF, $FOX;

        $QF->Run_Module('ConfSets');

        $cfg_sets = $QF->ConfSets->Get_List();

        if (!($cur_cfgset = $QF->GPC->Get_String('cfgset', QF_GPC_GET, QF_STR_WORD)))
            $cur_cfgset = 'common';
        if (!in_array($cur_cfgset, $cfg_sets))
            $cur_cfgset = $cfg_sets[0];

        $cfg_node = $QF->VIS->Create_Node('ADM_FRAME_CONFIGS', Array('CUR_CFGSET' => $cur_cfgset));
        $p_subtitle = $cur_cfgset;
        foreach ($cfg_sets as $set_id)
        {
            $vars = Array('set_id' => $set_id, 'set_capt' => $set_id);
            if ($set_id == $cur_cfgset)
                $vars['selected'] = 1;
            $QF->VIS->Add_Node('ADM_FRAME_CONFIGS_CFGSET', 'CFGSETS_LIST', $cfg_node, $vars);
        }

        $cfgs = $QF->ConfSets->Get_ConfSet($cur_cfgset);
        foreach ($cfgs as $vars)
        {
            $type = $vars['type'];
            if ($type == 'str')
            {
                $vars['cur_val'] = htmlspecialchars($QF->Config->Get($vars['cfg_name'], $vars['cfg_parent']));
                if (isset($vars['subtype']))
                {
                    $subtype = $vars['subtype'];
                    if ($subtype == 'e-mail')
                    {
                        if (!qf_str_is_email($vars['cur_val']))
                            $vars['cur_val'] = '';
                    }
                }
                $QF->VIS->Add_Node('ADM_FRAME_CONFIGS_CFG_STRING', 'CONFIGS_LIST', $cfg_node, $vars);
            }
            elseif ($type == 'text')
            {
                $vars['cur_val'] = htmlspecialchars($QF->Config->Get($vars['cfg_name'], $vars['cfg_parent']));
                $QF->VIS->Add_Node('ADM_FRAME_CONFIGS_CFG_TEXT', 'CONFIGS_LIST', $cfg_node, $vars);
            }
            elseif ($type == 'int')
            {
                $vars['cur_val'] = $QF->Config->Get($vars['cfg_name'], $vars['cfg_parent']);
                if (!is_null($vars['cur_val']))
                    $vars['cur_val'] = (int) $vars['cur_val'];
                if ($vars['max'] && (($vars['max'] - $vars['min']) < 30))
                    $QF->VIS->Add_Node('ADM_FRAME_CONFIGS_CFG_INTSEL', 'CONFIGS_LIST', $cfg_node, $vars);
                else
                    $QF->VIS->Add_Node('ADM_FRAME_CONFIGS_CFG_INT', 'CONFIGS_LIST', $cfg_node, $vars);
            }
            elseif ($type == 'bool')
            {
                $vars['cur_val'] = $QF->Config->Get($vars['cfg_name'], $vars['cfg_parent']);
                if (!is_null($vars['cur_val']))
                    $vars['cur_val'] = ($vars['cur_val']) ? 'true' : 'false';
                $QF->VIS->Add_Node('ADM_FRAME_CONFIGS_CFG_BOOL', 'CONFIGS_LIST', $cfg_node, $vars);
            }
            elseif ($type == 'select')
            {
                $vars['cur_val'] = $QF->Config->Get($vars['cfg_name'], $vars['cfg_parent']);
                $nnode = $QF->VIS->Add_Node('ADM_FRAME_CONFIGS_CFG_SELECT', 'CONFIGS_LIST', $cfg_node, $vars);
                $options = array();
                foreach ($vars['variants'] as $op_val => $op_name)
                    $options[] = Array('VAL' => $op_val, 'CAPT' => $op_name, 'SELECTED' => ($op_val == $vars['cur_val']) ? true : null);
                $QF->VIS->Add_Node_Array('ADM_FRAME_CONFIGS_CFG_SELOPT', 'OPTIONS', $nnode, $options);
            }
        }

        return $cfg_node;
    }

    function Script_Config()
    {
        global $QF, $FOX;
        $QF->Run_Module('ConfSets');
        $cur_cfgset = $QF->GPC->Get_String('cfgset', QF_GPC_POST, QF_STR_WORD);

        if ($acc_err = $this->_Scr_Check_Access())
        {
            return $acc_err;
        }
        elseif ($cfgs = $QF->ConfSets->Get_ConfSet($cur_cfgset))
        {
            $sets_data = $QF->GPC->Get_Raw('confs', QF_GPC_POST);
            $QF->Run_Module('Parser');

            $dropped = Array();
            $drop_ch = false;
            foreach ($cfgs as $vars)
            {
                $type = $vars['type'];
                $varname = $vars['cfg_name'];
                if (!isset($sets_data[$varname]))
                    continue;

                $cval = (string) $sets_data[$varname];
                if ($vars['drops_ch']) // checking for cache drop needed
                {
                    $oval = (string) $QF->Config->Get($varname, $vars['cfg_parent']);
                    if ($oval !== $cval)
                        $drop_ch = true;
                }

                if ($cval === '')
                {
                    $QF->Config->Set($varname, null, $vars['cfg_parent'], true);
                    continue;
                }

                if ($type == 'str' || $type == 'text')
                {
                    if ($c_recoded = $QF->Session->Get('recode_out'))
                        if ($val = $QF->USTR->Str_Convert($cval, QF_INTERNAL_ENCODING, $c_recoded))
                            $cval = $val;
                    $subtype = (isset($vars['subtype'])) ? $vars['subtype'] : '';

                    if ($type == 'str')
                    {
                        $cval = preg_replace('#[\r\n]#', '', $cval);
                        if ($subtype == 'e-mail')
                        {
                            if (!qf_str_is_email($cval))
                                $cval = null;
                        }
                    }

                    if ($subtype == 'html')
                    {
                        $cval = $QF->Parser->XML_Check($cval, true);
                    }

                    $mylen = $QF->USTR->Str_Len($cval);
                    if ($vars['max'] && ($mylen > $vars['max']))
                        $cval = $QF->USTR->Str_Substr($cval, 0, $vars['max']);
                    elseif ($vars['min'] && ($mylen < $vars['min']))
                        $cval = null;
                }
                elseif ($type == 'int')
                {
                    $cval = (int) $cval;
                    if ($vars['max'] && ($cval > $vars['max']))
                        $cval = $vars['max'];
                    elseif ($vars['min'] && ($cval < $vars['min']))
                        $cval = null;
                }
                elseif ($type == 'bool')
                {
                    $cval = ($cval)
                        ? 1
                        : 0;
                }
                elseif ($type == 'select')
                {
                    $variants = array_keys($vars['variants']);
                    if (!in_array($cval, $variants))
                        $cval = null;
                }

                if (is_null($cval))
                    $dropped[] = '['.$vars['cfg_parent'].' => '.$varname.']';
                else
                    $QF->Config->Set($varname, $cval, $vars['cfg_parent'], true);
            }

            $result = sprintf($QF->LNG->Lang('ADMPANEL_CFGSET_UPDATED'), $cur_cfgset);
            if ($dropped)
                $result.= ' '.sprintf($QF->LNG->Lang('ADMPANEL_CFGSET_UPD_MISSED'), implode('; ', $dropped));
            if ($drop_ch)
                $QF->Cache->Clear();

            return Array($result, $FOX->Gen_URL('fox2_adm_configs_cfgset', Array($cur_cfgset)));
        }
        else
            return Array($QF->LNG->lang('ADMPANEL_QUERY_ERROR'), $FOX->Gen_URL('fox2_adm_configs_cfgset', Array($cur_cfgset)), true);
    }

    function AdmP_MenuEd(&$p_subtitle)
    {
        global $QF, $FOX;

        $cfg_node = $QF->VIS->Create_Node('ADM_FRAME_MENUED');

        $items = $QF->Config->Get('menu_buttons', 'visual');
        if (!is_array($items))
            $items = Array();
        $ord = 1;
        foreach ($items as $itm)
        {
            $itm['order'] = $ord++;
            $QF->VIS->Add_Node('ADM_FRAME_MENUED_ITEM', 'ITEMS_LIST', $cfg_node, qf_value_htmlschars($itm));
        }
        for ($i=0; $i<3; $i++)
            $QF->VIS->Add_Node('ADM_FRAME_MENUED_ITEM', 'ITEMS_LIST', $cfg_node, Array('order' => $ord++));

        return $cfg_node;
    }

    function Script_MenuEd()
    {
        global $QF, $FOX;
        $menu_data = $QF->GPC->Get_Raw('menuitms', QF_GPC_POST);

        if ($acc_err = $this->_Scr_Check_Access())
        {
            return $acc_err;
        }
        elseif (is_array($menu_data))
        {
            $menu_data = qf_array_2dresort($menu_data, 'order', false, SORT_NUMERIC);
            $dropped = Array();
            $menu_cfg = Array();
            foreach ($menu_data as $itm)
            {
                if (!isset($itm['caption'], $itm['url']))
                    continue;

                $capt = $itm['caption'];
                $mylen = $QF->USTR->Str_Len($capt);
                if ($mylen > 20)
                    $cval = $QF->USTR->Str_Substr($cval, 0, 20);
                elseif ($mylen < 3)
                    continue;

                $url = $itm['url'];
                if (!qf_str_is_url($url))
                {
                    $url = '#';
                    $dropped[] = $capt;
                }

                $is_sub = isset($itm['is_sub']) ? (($itm['is_sub']) ? 1 : 0) : 0;

                $menu_cfg[] = Array(
                    'caption' => $capt,
                    'url'     => $url,
                    'is_sub'  => $is_sub,
                    );
            }
            $menu_cfg[0]['is_sub'] = 0;

            $QF->Config->Set('menu_buttons', $menu_cfg, 'visual', true);

            $result = $QF->LNG->Lang('ADMPANEL_MENUED_UPDATED');
            if ($dropped)
                $result.= sprintf($QF->LNG->Lang('ADMPANEL_MENUED_URL_DROPPED'), implode('; ', $dropped));

            return Array($result, $FOX->Gen_URL('fox2_adm_panel_admp', Array('menued')));
        }

        return Array($QF->LNG->lang('ADMPANEL_QUERY_ERROR'), $FOX->Gen_URL('fox2_adm_panel_admp', Array('menued')), true);
    }


    function Script_Login()
    {
        global $QF, $FOX;

        $login = $QF->GPC->Get_String('login', QF_GPC_POST, QF_STR_WORD);
        $pass  = $QF->GPC->Get_String('pass', QF_GPC_POST);
        $redir_uri = $QF->GPC->Get_String('pan_uri', QF_GPC_POST);

        if (!$QF->User->UID || !$QF->User->adm_level)
        {
            return Array(Lang('ADMPANEL_ERR_NOADMIN'), QF_INDEX, true);
        }
        elseif ($cuser = $QF->DBase->Do_Select('users_auth', '*', Array('login' => $login)))
        {
            $uid = $cuser['uid'];
            $pass_hash = md5($pass);
            if ($pass_salt = $cuser['pass_salt'])
                $pass_hash = md5(md5($pass_salt).$pass_hash);

            if ($uid!= $QF->User->UID)
            {
                $QF->DBase->Do_Update('users', Array('sess_id' => ''), Array('uid' => $cuid));
                if ($u_al = $QF->User->S_Get('U_AL'))
                    $QF->DBase->Do_Delete('users_al', Array('al_id' => $u_al));
                $QF->HTTP->Set_Cookie('QF2_Login');
                $QF->Session->Drop('UID');
                $QF->User->S_Clear();
                return Array(Lang('ADMPANEL_ERR_LOGIN_NOTME'), QF_INDEX, true);
            }
            elseif ($cuser['pass_hash'] == $pass_hash)
            {
                $new_salt = substr(md5(uniqid('QF_salt', true)), rand(0, 24), 7);
                $new_hash = md5(md5($new_salt).md5($pass));

                $upd_data = Array(
                    'pass_hash' => $new_hash,
                    'pass_salt' => $new_salt,
                    );

                $QF->DBase->Do_Update('users_auth', $upd_data, Array('uid' => $cuser['uid']));
                $QF->User->S_Set('adm_logged', true);

                return Array(Lang('ADMPANEL_RES_LOGIN_LOGGED'), (qf_str_is_url($redir_uri)) ? qf_full_url($redir_uri) : $FOX->Gen_URL('fox2_adm_panel'));
            }
            else
                return Array(Lang('ERR_LOGIN_ERRDATA'), $FOX->Gen_URL('fox2_adm_panel'), true);
        }
        else
        {
            $QF->DBase->Do_Update('users', Array('sess_id' => ''), Array('uid' => $cuid));
            if ($u_al = $QF->User->S_Get('U_AL'))
                $QF->DBase->Do_Delete('users_al', Array('al_id' => $u_al));
            $QF->HTTP->Set_Cookie('QF2_Login');
            $QF->Session->Drop('UID');
            $QF->User->S_Clear();
            return Array(Lang('ADMPANEL_ERR_LOGIN_NOTME'), QF_INDEX, true);
        }

    }

    function _Scr_Check_Access()
    {
        global $QF;

        if (!$QF->User->UID || !$QF->User->adm_level)
        {
            return Array(Lang('ADMPANEL_ERR_NOADMIN'), QF_INDEX, true);
        }
        elseif (!$QF->User->S_Get('adm_logged'))
        {
            return Array(Lang('ADMPANEL_LOGIN_REQUEST'), QF_INDEX, true);
        }
        else
            return false;
    }
}

?>
